(define (print . args)
  (for-each
   (lambda (x)
     (format *stderr* "~A " x))
   args)
  (format *stderr* "\n"))

(define async-call
  (let ((counter 0))
    (lambda (cb)
      (set-timeout 1000 (lambda () (cb (format #f "response~A" counter))))
      (set! counter (+ 1 counter)))))

(define (main)
  (call-with-exit
   (lambda (return)
     (define foo
       (call/cc
	(lambda (cc)
	  (define cb (lambda (res)
		       (cc res)))
	  (async-call cb)
	  cc)))
     (when (continuation? foo)
       (return))
     (print "foo is" foo)
     (define bar
       (call/cc
	(lambda (cc)
	  (define cb2 (lambda (res)
			(cc res)))
	  (async-call cb2)
	  cc)))
     (when (continuation? bar)
	 (return))
     (print "foo is" foo "bar is" bar)
     (print "done!"))))

;; if we call (main) here: doesn't work
;; (main)
;; But! if we evaluate (main) in the repl: it works!

